/*
 * command.c
 *
 * Execute the given command and wait for an answer.
 *
 */

#include "../include/voice.h"

char *libvoice_command_c = "$Id: command.c,v 1.3 1996/08/06 19:50:26 marc Exp $";

int voice_command _P2((command, expected_answer), char *command,
 char *expected_answer)
     {
     char buffer[VOICE_BUF_LEN];
     int result = VMA_FAIL;

     lprintf(L_NOISE, "voice command: '%s' -> '%s'", command,
      expected_answer);

     if (strlen(command) != 0)
          {
          voice_flush(0);

          if (voice_write("%s", command) != OK)
               {
               voice_flush(1);
               return(VMA_FAIL);
               };

          do
               {

               if (voice_read(buffer) != OK)
                    {
                    voice_flush(1);
                    return(VMA_FAIL);
                    };

               result = voice_analyze(buffer, command);

               if (result == VMA_FAIL)
                    {
                    lprintf(L_ERROR, "modem did not echo the command");
                    voice_flush(1);
                    return(VMA_FAIL);
                    };

               if (result == VMA_ERROR)
                    {
                    lprintf(L_ERROR, "modem returned ERROR");
                    voice_flush(1);
                    return(VMA_FAIL);
                    };

               }
          while (result != VMA_USER_1);

          result = OK;
          };

     if (strlen(expected_answer) != 0)
          {

          do
               {

               if (voice_read(buffer) != OK)
                    {
                    voice_flush(1);
                    return(VMA_FAIL);
                    };

               result = voice_analyze(buffer, expected_answer);

               if (result == VMA_FAIL)
                    {
                    lprintf(L_ERROR, "invalid modem answer");
                    voice_flush(1);
                    return(VMA_FAIL);
                    };

               if (result == VMA_ERROR)
                    {
                    lprintf(L_ERROR, "modem returned ERROR");
                    voice_flush(1);
                    return(VMA_FAIL);
                    };

               }
          while ((result & VMA_USER) != VMA_USER);

          };

     return(result);
     };
